﻿//////////////////////////////////////////////
// MeshSaveQuery.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Mesh ;
}

/// Includes ---------------------------------

// nkGraphics
#include "MeshFormat.h"

#include "../../Dll/DllDefines.h"

// Standards
#include <string>
#include <vector>

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT MeshSaveQuery
	{
		private :
		
			// Attributs
			// Path du fichier
			std::string _fileName ;

			// Le mesh concerné
			std::vector<Mesh*> _mesh ;

			// Le format souhaité
			MESH_FORMAT _format ;

			// Si on fait en async
			bool _asynchronous ;
			
		public :
		
			// Constructeur, destructeur
			MeshSaveQuery () ;
			~MeshSaveQuery () ;

			// Getters
			const char* getFileName () const ;
			Mesh* getMesh (unsigned int index) const ;
			MESH_FORMAT getFormat () const ;
			bool getAsynchronous () const ;

			// Setters
			void setFileName (const char* value) ;
			void addMesh (Mesh* value) ;
			void setFormat (MESH_FORMAT value) ;
			void setAsynchronous (bool value) ;
	} ;
}