﻿//////////////////////////////////////////////
// Namespace.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Function ;
	class UserType ;
}

/// Includes ---------------------------------

// nkScripts
#include "../../Dll/DllDefines.h"

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>

/// Class ------------------------------------

namespace nkScripts
{
	class DLL_SCRIPTS_EXPORT Namespace
	{
		protected :

			// Nom interne
			std::string _name ;

		public :

			// Constructeur, destructeur
			Namespace (const nkMemory::StringView& name) ;
			virtual ~Namespace () ;

			// Getters
			nkMemory::StringView getName () const ;

			// Constrôles : Getters
			virtual Namespace* getNamespace (const nkMemory::StringView& name) const = 0 ;
			virtual UserType* getUserType (const nkMemory::StringView& name) const = 0 ;

			// Contrôles : Setters
			virtual void setVar (const nkMemory::StringView& name, int value) = 0 ;
			virtual void setObject (const nkMemory::StringView& name, const nkMemory::StringView& userTypeName, void* value) = 0 ;

			virtual Namespace* setNamespace (const nkMemory::StringView& name) = 0 ;
			virtual UserType* setUserType (const nkMemory::StringView& name) = 0 ;
			virtual Function* setFunc (const nkMemory::StringView& name) = 0 ;

			virtual void shutdown () = 0 ;
			virtual void reset () = 0 ;
	} ;
}