﻿//////////////////////////////////////////////
// LogManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkLog
{
	class Logger ;
}

/// Includes ---------------------------------

// nkScripts
#include "../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------

namespace nkScripts
{
	class DLL_SCRIPTS_EXPORT LogManager final : public nkCommon::SingletonClass<LogManager>
	{
		friend class nkCommon::SingletonClass<LogManager> ;

		private :
			
			// Attributes
			// Le logger enregistré
			nkLog::Logger* _receiver ;

		private :

			// Functions
			// Constructeur, destructeur
			LogManager () ;
			~LogManager () ;

		public :

			// Getters
			nkLog::Logger* getReceiver () const ;

			// Setters
			void setReceiver (nkLog::Logger* receiver) ;

			// Log
			void log (const nkMemory::StringView& message, const nkMemory::StringView& className) ;
	} ;
}

