﻿//////////////////////////////////////////////
// EditBox.h
//
//////////////////////////////////////////////

/// Defines / Macro --------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

#include "../Inputs/CallbackRepository.h"

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT EditBox : public Component
	{
		protected :

			// Attributs
			// Si nous ne sommes que des chiffres ou pas
			bool _onlyNumbers ;
			// Le place holder
			std::string _placeHolder ;

			// Callback
			editBoxKeyCallback _callback ;
		
		public :
		
			// Constructeur, destructeur
			EditBox () ;
			~EditBox () ;

			// Getters
			editBoxKeyCallback getKeySpecializedCallback () const ;

			// Setters
			virtual void setOnlyNumbers (bool value) ;
			virtual void setPlaceHolder (const std::string_view& text) ;
			virtual void setCaretPosition (unsigned int letterIndex) = 0 ;
			void setKeySpecializedCallback (editBoxKeyCallback value) ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}