﻿//////////////////////////////////////////////
// LogManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkLog
{
	class Logger ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

// Common
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <string_view>

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT LogManager final : public nkCommon::SingletonClass<LogManager>
	{
		friend class nkCommon::SingletonClass<LogManager> ;

		private :

			// Constructeur, destructeur
			LogManager () ;
			~LogManager () ;
		
			// Attributes
			nkLog::Logger* _receiver ;
			
		public :

			// Getters
			nkLog::Logger* getReceiver () const ;
		
			// Setters
			void setReceiver (nkLog::Logger* receiver) ;

			// Log
			void log (const std::string_view& message, const std::string_view& className) ;
	} ;
}